diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/bindings/modulegen__gcc_LP64.py ns-3.36/src/internet/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/internet/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.854733500 -0700
@@ -16668,7 +16639,7 @@
                    'uint8_t', 
                    [], 
                    is_const=True, is_virtual=True)
-    ## ipv6-extension.h (module 'internet'): void ns3::Ipv6ExtensionFragment::GetFragments(ns3::Ptr<ns3::Packet> packet, ns3::Ipv6Header ipv6Header, uint32_t fragmentSize, std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header> > > & listFragments) [member function]
+    ## ipv6-extension.h (module 'internet'): void ns3::Ipv6ExtensionFragment::GetFragments(ns3::Ptr<ns3::Packet> packet, ns3::Ipv6Header ipv6Header, uint32_t fragmentSize, std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>>> & listFragments) [member function]
     cls.add_method('GetFragments', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Ipv6Header', 'ipv6Header'), param('uint32_t', 'fragmentSize'), param('std::list< std::pair< ns3::Ptr< ns3::Packet >, ns3::Ipv6Header > > &', 'listFragments')])
@@ -16799,7 +16770,7 @@
                    'ns3::Ipv6Address', 
                    [param('uint8_t', 'index')], 
                    is_const=True)
-    ## ipv6-extension-header.h (module 'internet'): std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address> > ns3::Ipv6ExtensionLooseRoutingHeader::GetRoutersAddress() const [member function]
+    ## ipv6-extension-header.h (module 'internet'): std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address>> ns3::Ipv6ExtensionLooseRoutingHeader::GetRoutersAddress() const [member function]
     cls.add_method('GetRoutersAddress', 
                    'std::vector< ns3::Ipv6Address >', 
                    [], 
@@ -16832,7 +16803,7 @@
     cls.add_method('SetRouterAddress', 
                    'void', 
                    [param('uint8_t', 'index'), param('ns3::Ipv6Address', 'addr')])
-    ## ipv6-extension-header.h (module 'internet'): void ns3::Ipv6ExtensionLooseRoutingHeader::SetRoutersAddress(std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address> > routersAddress) [member function]
+    ## ipv6-extension-header.h (module 'internet'): void ns3::Ipv6ExtensionLooseRoutingHeader::SetRoutersAddress(std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address>> routersAddress) [member function]
     cls.add_method('SetRoutersAddress', 
                    'void', 
                    [param('std::vector< ns3::Ipv6Address >', 'routersAddress')])
@@ -17362,7 +17333,7 @@
                    'ns3::Ipv6Address', 
                    [], 
                    is_const=True)
-    ## ipv6-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int> > > ns3::Ipv6MulticastRoute::GetOutputTtlMap() const [member function]
+    ## ipv6-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int>>> ns3::Ipv6MulticastRoute::GetOutputTtlMap() const [member function]
     cls.add_method('GetOutputTtlMap', 
                    'std::map< unsigned int, unsigned int >', 
                    [], 
@@ -17743,7 +17714,7 @@
     cls.add_method('AddHostRouteTo', 
                    'void', 
                    [param('ns3::Ipv6Address', 'dest'), param('uint32_t', 'interface'), param('uint32_t', 'metric', default_value='0')])
-    ## ipv6-static-routing.h (module 'internet'): void ns3::Ipv6StaticRouting::AddMulticastRoute(ns3::Ipv6Address origin, ns3::Ipv6Address group, uint32_t inputInterface, std::vector<unsigned int, std::allocator<unsigned int> > outputInterfaces) [member function]
+    ## ipv6-static-routing.h (module 'internet'): void ns3::Ipv6StaticRouting::AddMulticastRoute(ns3::Ipv6Address origin, ns3::Ipv6Address group, uint32_t inputInterface, std::vector<unsigned int, std::allocator<unsigned int>> outputInterfaces) [member function]
     cls.add_method('AddMulticastRoute', 
                    'void', 
                    [param('ns3::Ipv6Address', 'origin'), param('ns3::Ipv6Address', 'group'), param('uint32_t', 'inputInterface'), param('std::vector< unsigned int >', 'outputInterfaces')])
@@ -17992,7 +17963,7 @@
                    'ns3::NdiscCache::Entry *', 
                    [param('ns3::Ipv6Address', 'dst')], 
                    is_virtual=True)
-    ## ndisc-cache.h (module 'internet'): std::list<ns3::NdiscCache::Entry *, std::allocator<ns3::NdiscCache::Entry *> > ns3::NdiscCache::LookupInverse(ns3::Address dst) [member function]
+    ## ndisc-cache.h (module 'internet'): std::list<ns3::NdiscCache::Entry *, std::allocator<ns3::NdiscCache::Entry *>> ns3::NdiscCache::LookupInverse(ns3::Address dst) [member function]
     cls.add_method('LookupInverse', 
                    'std::list< ns3::NdiscCache::Entry * >', 
                    [param('ns3::Address', 'dst')])
@@ -18117,7 +18088,7 @@
     cls.add_method('MarkProbe', 
                    'void', 
                    [])
-    ## ndisc-cache.h (module 'internet'): std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header> > > ns3::NdiscCache::Entry::MarkReachable(ns3::Address mac) [member function]
+    ## ndisc-cache.h (module 'internet'): std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>>> ns3::NdiscCache::Entry::MarkReachable(ns3::Address mac) [member function]
     cls.add_method('MarkReachable', 
                    'std::list< std::pair< ns3::Ptr< ns3::Packet >, ns3::Ipv6Header > >', 
                    [param('ns3::Address', 'mac')])
@@ -18125,7 +18096,7 @@
     cls.add_method('MarkReachable', 
                    'void', 
                    [])
-    ## ndisc-cache.h (module 'internet'): std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header> > > ns3::NdiscCache::Entry::MarkStale(ns3::Address mac) [member function]
+    ## ndisc-cache.h (module 'internet'): std::list<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>, std::allocator<std::pair<ns3::Ptr<ns3::Packet>, ns3::Ipv6Header>>> ns3::NdiscCache::Entry::MarkStale(ns3::Address mac) [member function]
     cls.add_method('MarkStale', 
                    'std::list< std::pair< ns3::Ptr< ns3::Packet >, ns3::Ipv6Header > >', 
                    [param('ns3::Address', 'mac')])
@@ -18336,10 +18307,16 @@
     cls.add_method('ExtractNeighborIndex', 
                    'uint32_t', 
                    [param('uint32_t', 'numberOfBits')])
-    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetEpoch() const [member function]
+    cls.add_method('GetEpoch', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() const [member function]
     cls.add_method('GetRemainingBits', 
                    'uint32_t', 
-                   [])
+                   [], 
+                   is_const=True)
     ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
@@ -18350,6 +18327,10 @@
                    'uint32_t', 
                    [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
+    ## nix-vector.h (module 'network'): void ns3::NixVector::SetEpoch(uint32_t epoch) [member function]
+    cls.add_method('SetEpoch', 
+                   'void', 
+                   [param('uint32_t', 'epoch')])
     return
 
 def register_Ns3Node_methods(root_module, cls):
@@ -18726,10 +18707,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
@@ -18846,7 +18828,7 @@
     cls.add_method('AssignStreams', 
                    'int64_t', 
                    [param('int64_t', 'stream')])
-    ## rip.h (module 'internet'): std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> > ns3::Rip::GetInterfaceExclusions() const [member function]
+    ## rip.h (module 'internet'): std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int>> ns3::Rip::GetInterfaceExclusions() const [member function]
     cls.add_method('GetInterfaceExclusions', 
                    'std::set< unsigned int >', 
                    [], 
@@ -18896,7 +18878,7 @@
                    'ns3::Ptr< ns3::Ipv4Route >', 
                    [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Ipv4Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice >', 'oif'), param('ns3::Socket::SocketErrno &', 'sockerr')], 
                    is_virtual=True)
-    ## rip.h (module 'internet'): void ns3::Rip::SetInterfaceExclusions(std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> > exceptions) [member function]
+    ## rip.h (module 'internet'): void ns3::Rip::SetInterfaceExclusions(std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int>> exceptions) [member function]
     cls.add_method('SetInterfaceExclusions', 
                    'void', 
                    [param('std::set< unsigned int >', 'exceptions')])
@@ -18934,7 +18916,7 @@
     cls.add_method('AssignStreams', 
                    'int64_t', 
                    [param('int64_t', 'stream')])
-    ## ripng.h (module 'internet'): std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> > ns3::RipNg::GetInterfaceExclusions() const [member function]
+    ## ripng.h (module 'internet'): std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int>> ns3::RipNg::GetInterfaceExclusions() const [member function]
     cls.add_method('GetInterfaceExclusions', 
                    'std::set< unsigned int >', 
                    [], 
@@ -18994,7 +18976,7 @@
                    'ns3::Ptr< ns3::Ipv6Route >', 
                    [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Ipv6Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice >', 'oif'), param('ns3::Socket::SocketErrno &', 'sockerr')], 
                    is_virtual=True)
-    ## ripng.h (module 'internet'): void ns3::RipNg::SetInterfaceExclusions(std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> > exceptions) [member function]
+    ## ripng.h (module 'internet'): void ns3::RipNg::SetInterfaceExclusions(std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int>> exceptions) [member function]
     cls.add_method('SetInterfaceExclusions', 
                    'void', 
                    [param('std::set< unsigned int >', 'exceptions')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/CMakeLists.txt ns-3.36/src/internet/CMakeLists.txt
--- ns-3.35/src/internet/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/internet/CMakeLists.txt	2022-04-30 18:23:57.850733500 -0700
@@ -0,0 +1,339 @@
+set(source_files
+    helper/internet-stack-helper.cc
+    helper/internet-trace-helper.cc
+    helper/ipv4-address-helper.cc
+    helper/ipv4-global-routing-helper.cc
+    helper/ipv4-interface-container.cc
+    helper/ipv4-list-routing-helper.cc
+    helper/ipv4-routing-helper.cc
+    helper/ipv4-static-routing-helper.cc
+    helper/ipv6-address-helper.cc
+    helper/ipv6-interface-container.cc
+    helper/ipv6-list-routing-helper.cc
+    helper/ipv6-routing-helper.cc
+    helper/ipv6-static-routing-helper.cc
+    helper/rip-helper.cc
+    helper/ripng-helper.cc
+    model/arp-cache.cc
+    model/arp-header.cc
+    model/arp-l3-protocol.cc
+    model/arp-queue-disc-item.cc
+    model/candidate-queue.cc
+    model/global-route-manager-impl.cc
+    model/global-route-manager.cc
+    model/global-router-interface.cc
+    model/icmpv4-l4-protocol.cc
+    model/icmpv4.cc
+    model/icmpv6-header.cc
+    model/icmpv6-l4-protocol.cc
+    model/ip-l4-protocol.cc
+    model/ipv4-address-generator.cc
+    model/ipv4-end-point-demux.cc
+    model/ipv4-end-point.cc
+    model/ipv4-global-routing.cc
+    model/ipv4-header.cc
+    model/ipv4-interface-address.cc
+    model/ipv4-interface.cc
+    model/ipv4-l3-protocol.cc
+    model/ipv4-list-routing.cc
+    model/ipv4-packet-filter.cc
+    model/ipv4-packet-info-tag.cc
+    model/ipv4-packet-probe.cc
+    model/ipv4-queue-disc-item.cc
+    model/ipv4-raw-socket-factory-impl.cc
+    model/ipv4-raw-socket-factory.cc
+    model/ipv4-raw-socket-impl.cc
+    model/ipv4-route.cc
+    model/ipv4-routing-protocol.cc
+    model/ipv4-routing-table-entry.cc
+    model/ipv4-static-routing.cc
+    model/ipv4.cc
+    model/ipv6-address-generator.cc
+    model/ipv6-autoconfigured-prefix.cc
+    model/ipv6-end-point-demux.cc
+    model/ipv6-end-point.cc
+    model/ipv6-extension-demux.cc
+    model/ipv6-extension-header.cc
+    model/ipv6-extension.cc
+    model/ipv6-header.cc
+    model/ipv6-interface-address.cc
+    model/ipv6-interface.cc
+    model/ipv6-l3-protocol.cc
+    model/ipv6-list-routing.cc
+    model/ipv6-option-demux.cc
+    model/ipv6-option-header.cc
+    model/ipv6-option.cc
+    model/ipv6-packet-filter.cc
+    model/ipv6-packet-info-tag.cc
+    model/ipv6-packet-probe.cc
+    model/ipv6-pmtu-cache.cc
+    model/ipv6-queue-disc-item.cc
+    model/ipv6-raw-socket-factory-impl.cc
+    model/ipv6-raw-socket-factory.cc
+    model/ipv6-raw-socket-impl.cc
+    model/ipv6-route.cc
+    model/ipv6-routing-protocol.cc
+    model/ipv6-routing-table-entry.cc
+    model/ipv6-static-routing.cc
+    model/ipv6.cc
+    model/loopback-net-device.cc
+    model/ndisc-cache.cc
+    model/pending-data.cc
+    model/rip-header.cc
+    model/rip.cc
+    model/ripng-header.cc
+    model/ripng.cc
+    model/rtt-estimator.cc
+    model/tcp-bbr.cc
+    model/tcp-bic.cc
+    model/tcp-congestion-ops.cc
+    model/tcp-cubic.cc
+    model/tcp-dctcp.cc
+    model/tcp-header.cc
+    model/tcp-highspeed.cc
+    model/tcp-htcp.cc
+    model/tcp-hybla.cc
+    model/tcp-illinois.cc
+    model/tcp-l4-protocol.cc
+    model/tcp-ledbat.cc
+    model/tcp-linux-reno.cc
+    model/tcp-lp.cc
+    model/tcp-option-rfc793.cc
+    model/tcp-option-sack-permitted.cc
+    model/tcp-option-sack.cc
+    model/tcp-option-ts.cc
+    model/tcp-option-winscale.cc
+    model/tcp-option.cc
+    model/tcp-prr-recovery.cc
+    model/tcp-rate-ops.cc
+    model/tcp-recovery-ops.cc
+    model/tcp-rx-buffer.cc
+    model/tcp-scalable.cc
+    model/tcp-socket-base.cc
+    model/tcp-socket-factory-impl.cc
+    model/tcp-socket-factory.cc
+    model/tcp-socket-state.cc
+    model/tcp-socket.cc
+    model/tcp-tx-buffer.cc
+    model/tcp-tx-item.cc
+    model/tcp-vegas.cc
+    model/tcp-veno.cc
+    model/tcp-westwood.cc
+    model/tcp-yeah.cc
+    model/udp-header.cc
+    model/udp-l4-protocol.cc
+    model/udp-socket-factory-impl.cc
+    model/udp-socket-factory.cc
+    model/udp-socket-impl.cc
+    model/udp-socket.cc
+)
+
+set(header_files
+    ${header_files}
+    helper/internet-stack-helper.h
+    helper/internet-trace-helper.h
+    helper/ipv4-address-helper.h
+    helper/ipv4-global-routing-helper.h
+    helper/ipv4-interface-container.h
+    helper/ipv4-list-routing-helper.h
+    helper/ipv4-routing-helper.h
+    helper/ipv4-static-routing-helper.h
+    helper/ipv6-address-helper.h
+    helper/ipv6-interface-container.h
+    helper/ipv6-list-routing-helper.h
+    helper/ipv6-routing-helper.h
+    helper/ipv6-static-routing-helper.h
+    helper/rip-helper.h
+    helper/ripng-helper.h
+    model/arp-cache.h
+    model/arp-header.h
+    model/arp-l3-protocol.h
+    model/arp-queue-disc-item.h
+    model/candidate-queue.h
+    model/global-route-manager-impl.h
+    model/global-route-manager.h
+    model/global-router-interface.h
+    model/icmpv4-l4-protocol.h
+    model/icmpv4.h
+    model/icmpv6-header.h
+    model/icmpv6-l4-protocol.h
+    model/ip-l4-protocol.h
+    model/ipv4-address-generator.h
+    model/ipv4-end-point-demux.h
+    model/ipv4-end-point.h
+    model/ipv4-global-routing.h
+    model/ipv4-header.h
+    model/ipv4-interface-address.h
+    model/ipv4-interface.h
+    model/ipv4-l3-protocol.h
+    model/ipv4-list-routing.h
+    model/ipv4-packet-filter.h
+    model/ipv4-packet-info-tag.h
+    model/ipv4-packet-probe.h
+    model/ipv4-queue-disc-item.h
+    model/ipv4-raw-socket-factory.h
+    model/ipv4-raw-socket-impl.h
+    model/ipv4-route.h
+    model/ipv4-routing-protocol.h
+    model/ipv4-routing-table-entry.h
+    model/ipv4-static-routing.h
+    model/ipv4.h
+    model/ipv6-address-generator.h
+    model/ipv6-end-point-demux.h
+    model/ipv6-end-point.h
+    model/ipv6-extension-demux.h
+    model/ipv6-extension-header.h
+    model/ipv6-extension.h
+    model/ipv6-header.h
+    model/ipv6-interface-address.h
+    model/ipv6-interface.h
+    model/ipv6-l3-protocol.h
+    model/ipv6-list-routing.h
+    model/ipv6-option-header.h
+    model/ipv6-option.h
+    model/ipv6-packet-filter.h
+    model/ipv6-packet-info-tag.h
+    model/ipv6-packet-probe.h
+    model/ipv6-pmtu-cache.h
+    model/ipv6-queue-disc-item.h
+    model/ipv6-raw-socket-factory.h
+    model/ipv6-route.h
+    model/ipv6-routing-protocol.h
+    model/ipv6-routing-table-entry.h
+    model/ipv6-static-routing.h
+    model/ipv6.h
+    model/loopback-net-device.h
+    model/ndisc-cache.h
+    model/rip-header.h
+    model/rip.h
+    model/ripng-header.h
+    model/ripng.h
+    model/rtt-estimator.h
+    model/tcp-bbr.h
+    model/tcp-bic.h
+    model/tcp-congestion-ops.h
+    model/tcp-cubic.h
+    model/tcp-dctcp.h
+    model/tcp-header.h
+    model/tcp-highspeed.h
+    model/tcp-htcp.h
+    model/tcp-hybla.h
+    model/tcp-illinois.h
+    model/tcp-l4-protocol.h
+    model/tcp-ledbat.h
+    model/tcp-linux-reno.h
+    model/tcp-lp.h
+    model/tcp-option-rfc793.h
+    model/tcp-option-sack-permitted.h
+    model/tcp-option-sack.h
+    model/tcp-option-ts.h
+    model/tcp-option-winscale.h
+    model/tcp-option.h
+    model/tcp-prr-recovery.h
+    model/tcp-rate-ops.h
+    model/tcp-recovery-ops.h
+    model/tcp-rx-buffer.h
+    model/tcp-scalable.h
+    model/tcp-socket-base.h
+    model/tcp-socket-factory.h
+    model/tcp-socket-state.h
+    model/tcp-socket.h
+    model/tcp-tx-buffer.h
+    model/tcp-tx-item.h
+    model/tcp-vegas.h
+    model/tcp-veno.h
+    model/tcp-westwood.h
+    model/tcp-yeah.h
+    model/udp-header.h
+    model/udp-l4-protocol.h
+    model/udp-socket-factory.h
+    model/udp-socket.h
+    model/windowed-filter.h
+)
+
+set(test_sources
+    test/global-route-manager-impl-test-suite.cc
+    test/icmp-test.cc
+    test/ipv4-address-generator-test-suite.cc
+    test/ipv4-address-helper-test-suite.cc
+    test/ipv4-deduplication-test.cc
+    test/ipv4-forwarding-test.cc
+    test/ipv4-fragmentation-test.cc
+    test/ipv4-global-routing-test-suite.cc
+    test/ipv4-header-test.cc
+    test/ipv4-list-routing-test-suite.cc
+    test/ipv4-packet-info-tag-test-suite.cc
+    test/ipv4-raw-test.cc
+    test/ipv4-rip-test.cc
+    test/ipv4-static-routing-test-suite.cc
+    test/ipv4-test.cc
+    test/ipv6-address-duplication-test.cc
+    test/ipv6-address-generator-test-suite.cc
+    test/ipv6-address-helper-test-suite.cc
+    test/ipv6-dual-stack-test-suite.cc
+    test/ipv6-extension-header-test-suite.cc
+    test/ipv6-forwarding-test.cc
+    test/ipv6-fragmentation-test.cc
+    test/ipv6-list-routing-test-suite.cc
+    test/ipv6-packet-info-tag-test-suite.cc
+    test/ipv6-raw-test.cc
+    test/ipv6-ripng-test.cc
+    test/ipv6-test.cc
+    test/rtt-test.cc
+    test/tcp-advertised-window-test.cc
+    test/tcp-bbr-test.cc
+    test/tcp-bic-test.cc
+    test/tcp-bytes-in-flight-test.cc
+    test/tcp-classic-recovery-test.cc
+    test/tcp-close-test.cc
+    test/tcp-cong-avoid-test.cc
+    test/tcp-datasentcb-test.cc
+    test/tcp-dctcp-test.cc
+    test/tcp-ecn-test.cc
+    test/tcp-endpoint-bug2211.cc
+    test/tcp-error-model.cc
+    test/tcp-fast-retr-test.cc
+    test/tcp-general-test.cc
+    test/tcp-header-test.cc
+    test/tcp-highspeed-test.cc
+    test/tcp-htcp-test.cc
+    test/tcp-hybla-test.cc
+    test/tcp-illinois-test.cc
+    test/tcp-ledbat-test.cc
+    test/tcp-linux-reno-test.cc
+    test/tcp-loss-test.cc
+    test/tcp-lp-test.cc
+    test/tcp-option-test.cc
+    test/tcp-pacing-test.cc
+    test/tcp-pkts-acked-test.cc
+    test/tcp-prr-recovery-test.cc
+    test/tcp-rate-ops-test.cc
+    test/tcp-rto-test.cc
+    test/tcp-rtt-estimation.cc
+    test/tcp-rx-buffer-test.cc
+    test/tcp-sack-permitted-test.cc
+    test/tcp-scalable-test.cc
+    test/tcp-slow-start-test.cc
+    test/tcp-syn-connection-failed-test.cc
+    test/tcp-test.cc
+    test/tcp-timestamp-test.cc
+    test/tcp-tx-buffer-test.cc
+    test/tcp-vegas-test.cc
+    test/tcp-veno-test.cc
+    test/tcp-wscaling-test.cc
+    test/tcp-yeah-test.cc
+    test/tcp-zero-window-test.cc
+    test/udp-test.cc
+)
+
+build_lib(
+  LIBNAME internet
+  SOURCE_FILES ${source_files}
+  HEADER_FILES ${header_files}
+  LIBRARIES_TO_LINK
+    ${libnetwork}
+    ${libcore}
+    ${libbridge}
+    ${libtraffic-control}
+  TEST_SOURCES ${test_sources}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/examples/CMakeLists.txt ns-3.36/src/internet/examples/CMakeLists.txt
--- ns-3.35/src/internet/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/internet/examples/CMakeLists.txt	2022-04-30 18:23:57.858733400 -0700
@@ -0,0 +1,8 @@
+build_lib_example(
+  NAME main-simple
+  SOURCE_FILES main-simple.cc
+  LIBRARIES_TO_LINK
+    ${libnetwork}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/helper/internet-stack-helper.cc ns-3.36/src/internet/helper/internet-stack-helper.cc
--- ns-3.35/src/internet/helper/internet-stack-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/helper/internet-stack-helper.cc	2022-04-30 18:23:57.858733400 -0700
@@ -258,13 +258,6 @@
 }
 
 void 
-InternetStackHelper::SetTcp (std::string tid, std::string n0, const AttributeValue &v0)
-{
-  m_tcpFactory.SetTypeId (tid);
-  m_tcpFactory.Set (n0,v0);
-}
-
-void 
 InternetStackHelper::Install (NodeContainer c) const
 {
   for (NodeContainer::Iterator i = c.Begin (); i != c.End (); ++i)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/helper/internet-stack-helper.h ns-3.36/src/internet/helper/internet-stack-helper.h
--- ns-3.35/src/internet/helper/internet-stack-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/helper/internet-stack-helper.h	2022-04-30 18:23:57.858733400 -0700
@@ -186,20 +186,6 @@
   void SetTcp (std::string tid);
 
   /**
-   * \brief This function is used to setup the Network Simulation Cradle stack with library value.
-   * 
-   * Give the NSC stack a shared library file name to use when creating the 
-   * stack implementation.  The attr string is actually the attribute name to 
-   * be setup and val is its value. The attribute is the stack implementation 
-   * to be used and the value is the shared library name.
-   * 
-   * \param tid The type id, for the case of nsc it would be "ns3::NscTcpL4Protocol" 
-   * \param attr The attribute name that must be setup, for example "Library"
-   * \param val The attribute value, which will be in fact the shared library name (example:"liblinux2.6.26.so")
-   */
-  void SetTcp (std::string tid, std::string attr, const AttributeValue &val); 
-
-  /**
    * \brief Enable/disable IPv4 stack install.
    * \param enable enable state
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/arp-cache.cc ns-3.36/src/internet/model/arp-cache.cc
--- ns-3.35/src/internet/model/arp-cache.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/arp-cache.cc	2022-04-30 18:23:57.858733400 -0700
@@ -37,7 +37,7 @@
 
 NS_OBJECT_ENSURE_REGISTERED (ArpCache);
 
-TypeId 
+TypeId
 ArpCache::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ArpCache")
@@ -85,7 +85,7 @@
 }
 
 ArpCache::ArpCache ()
-  : m_device (0), 
+  : m_device (0),
     m_interface (0)
 {
   NS_LOG_FUNCTION (this);
@@ -96,7 +96,7 @@
   NS_LOG_FUNCTION (this);
 }
 
-void 
+void
 ArpCache::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
@@ -132,19 +132,19 @@
   return m_interface;
 }
 
-void 
+void
 ArpCache::SetAliveTimeout (Time aliveTimeout)
 {
   NS_LOG_FUNCTION (this << aliveTimeout);
   m_aliveTimeout = aliveTimeout;
 }
-void 
+void
 ArpCache::SetDeadTimeout (Time deadTimeout)
 {
   NS_LOG_FUNCTION (this << deadTimeout);
   m_deadTimeout = deadTimeout;
 }
-void 
+void
 ArpCache::SetWaitReplyTimeout (Time waitReplyTimeout)
 {
   NS_LOG_FUNCTION (this << waitReplyTimeout);
@@ -170,7 +170,7 @@
   return m_waitReplyTimeout;
 }
 
-void 
+void
 ArpCache::SetArpRequestCallback (Callback<void, Ptr<const ArpCache>,
                                           Ipv4Address> arpRequestCallback)
 {
@@ -178,7 +178,7 @@
   m_arpRequestCallback = arpRequestCallback;
 }
 
-void 
+void
 ArpCache::StartWaitReplyTimer (void)
 {
   NS_LOG_FUNCTION (this);
@@ -186,7 +186,7 @@
     {
       NS_LOG_LOGIC ("Starting WaitReplyTimer at " << Simulator::Now () << " for " <<
                     m_waitReplyTimeout);
-      m_waitReplyTimer = Simulator::Schedule (m_waitReplyTimeout, 
+      m_waitReplyTimer = Simulator::Schedule (m_waitReplyTimeout,
                                               &ArpCache::HandleWaitReplyTimeout, this);
     }
 }
@@ -197,7 +197,7 @@
   NS_LOG_FUNCTION (this);
   ArpCache::Entry* entry;
   bool restartWaitReplyTimer = false;
-  for (CacheI i = m_arpCache.begin (); i != m_arpCache.end (); i++) 
+  for (CacheI i = m_arpCache.begin (); i != m_arpCache.end (); i++)
     {
       entry = (*i).second;
       if (entry != 0 && entry->IsWaitReply ())
@@ -235,16 +235,16 @@
   if (restartWaitReplyTimer)
     {
       NS_LOG_LOGIC ("Restarting WaitReplyTimer at " << Simulator::Now ().GetSeconds ());
-      m_waitReplyTimer = Simulator::Schedule (m_waitReplyTimeout, 
+      m_waitReplyTimer = Simulator::Schedule (m_waitReplyTimeout,
                                               &ArpCache::HandleWaitReplyTimeout, this);
     }
 }
 
-void 
+void
 ArpCache::Flush (void)
 {
   NS_LOG_FUNCTION (this);
-  for (CacheI i = m_arpCache.begin (); i != m_arpCache.end (); i++) 
+  for (CacheI i = m_arpCache.begin (); i != m_arpCache.end (); i++)
     {
       delete (*i).second;
     }
@@ -342,7 +342,7 @@
 ArpCache::Remove (ArpCache::Entry *entry)
 {
   NS_LOG_FUNCTION (this << entry);
-  
+
   for (CacheI i = m_arpCache.begin (); i != m_arpCache.end (); i++)
     {
       if ((*i).second == entry)
@@ -365,34 +365,34 @@
 }
 
 
-bool 
+bool
 ArpCache::Entry::IsDead (void)
 {
   NS_LOG_FUNCTION (this);
-  return (m_state == DEAD) ? true : false;
+  return (m_state == DEAD);
 }
-bool 
+bool
 ArpCache::Entry::IsAlive (void)
 {
   NS_LOG_FUNCTION (this);
-  return (m_state == ALIVE) ? true : false;
+  return (m_state == ALIVE);
 }
 bool
 ArpCache::Entry::IsWaitReply (void)
 {
   NS_LOG_FUNCTION (this);
-  return (m_state == WAIT_REPLY) ? true : false;
+  return (m_state == WAIT_REPLY);
 }
 bool
 ArpCache::Entry::IsPermanent (void)
 {
   NS_LOG_FUNCTION (this);
-  return (m_state == PERMANENT) ? true : false;
+  return (m_state == PERMANENT);
 }
 
 
-void 
-ArpCache::Entry::MarkDead (void) 
+void
+ArpCache::Entry::MarkDead (void)
 {
   NS_LOG_FUNCTION (this);
   NS_ASSERT (m_state == ALIVE || m_state == WAIT_REPLY || m_state == DEAD);
@@ -401,7 +401,7 @@
   UpdateSeen ();
 }
 void
-ArpCache::Entry::MarkAlive (Address macAddress) 
+ArpCache::Entry::MarkAlive (Address macAddress)
 {
   NS_LOG_FUNCTION (this << macAddress);
   NS_ASSERT (m_state == WAIT_REPLY);
@@ -436,7 +436,7 @@
   m_pending.push_back (waiting);
   return true;
 }
-void 
+void
 ArpCache::Entry::MarkWaitReply (Ipv4PayloadHeaderPair waiting)
 {
   NS_LOG_FUNCTION (this << waiting.first);
@@ -456,13 +456,13 @@
   NS_LOG_FUNCTION (this);
   return m_macAddress;
 }
-void 
+void
 ArpCache::Entry::SetMacAddress (Address macAddress)
 {
   NS_LOG_FUNCTION (this);
   m_macAddress = macAddress;
 }
-Ipv4Address 
+Ipv4Address
 ArpCache::Entry::GetIpv4Address (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -493,17 +493,17 @@
       /* NOTREACHED */
     }
 }
-bool 
+bool
 ArpCache::Entry::IsExpired (void) const
 {
   NS_LOG_FUNCTION (this);
   Time timeout = GetTimeout ();
   Time delta = Simulator::Now () - m_lastSeen;
   NS_LOG_DEBUG ("delta=" << delta.GetSeconds () << "s");
-  if (delta > timeout) 
+  if (delta > timeout)
     {
       return true;
-    } 
+    }
   return false;
 }
 ArpCache::Ipv4PayloadHeaderPair
@@ -522,13 +522,13 @@
       return p;
     }
 }
-void 
+void
 ArpCache::Entry::ClearPendingPacket (void)
 {
   NS_LOG_FUNCTION (this);
   m_pending.clear ();
 }
-void 
+void
 ArpCache::Entry::UpdateSeen (void)
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/arp-cache.h ns-3.36/src/internet/model/arp-cache.h
--- ns-3.35/src/internet/model/arp-cache.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/arp-cache.h	2022-04-30 18:23:57.858733400 -0700
@@ -50,21 +50,6 @@
  */
 class ArpCache : public Object
 {
-private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  ArpCache (ArpCache const &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  ArpCache& operator= (ArpCache const &);
-
 public:
   /**
    * \brief Get the type ID.
@@ -72,9 +57,14 @@
    */
   static TypeId GetTypeId (void);
   class Entry;
+
   ArpCache ();
   ~ArpCache ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  ArpCache (ArpCache const &) = delete;
+  ArpCache & operator = (ArpCache const &) = delete;
+
   /**
    * \brief Set the NetDevice and Ipv4Interface associated with the ArpCache
    *
